/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor windows.c */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "barvy.h"
#include "windows.h"

int RCOLS, RLINES;

WINDOW *sub_informace, *sub_hlavni, *sub_nadpis, *sub_radek, *sub_psani, *new_hlavni;   /* extern; strukturyw.h */

int windows(char **chyba, type_uziv * slozka)
{
    char *chybanoecho[] = { " Chyba inicializace funkce noecho!\n",
        "              < OK >"
    };

    if (!isatty(fileno(stdout))) {
        *chyba = "Nejste pipojeni k terminlu: stdout!\n";
        return 1;
    }
    if (!isatty(fileno(stdin))) {
        *chyba = "Nejste pipojeni k terminlu: stdin!\n";
        return 1;
    }

    if (initscr2() == NULL) {
        *chyba = "Nepodarilo se inicializovat initscr";
        return 1;
    }

    RCOLS = COLS;
    RLINES = LINES;

    if (COLS < TERMCOLS || LINES < TERMLINES) {
        endwin2();
        fprintf(stderr, "%ix%i << %ix%i: ", COLS, LINES, TERMCOLS,
                TERMLINES);
        *chyba = "Terminal ma prilis malo radku nebo sloupcu.\n";
        return 1;
    }

    if (!has_colors2()) {
        endwin2();
        *chyba = "Neexistuje podpora barev na tomto terminlu\n";
        return 1;
    }

    if (start_color2() != OK) {
        endwin2();
        *chyba = "Nepodailo se inicializovat barvy\n";
        return 1;
    }
    use_default_colors2();

    if (COLOR_POCET > COLOR_PAIRS) {
        endwin2();
        *chyba = "Pli mlo povolench barevnch pr\n";
        return 1;
    }

    /* ------------------- vytvareni oken -------------------- */
    /* aby nebylo zakryte cele stdscr bude new_hlavni o neco kratsi */
    /* i = HLPRINTLINES; == LINES - 5 - ((LINES - 25) * 0.25); */
    if ((new_hlavni = newwin2(HLPRINTLINES, COLS, 0, 0)) == NULL) {
        endwin2();
        *chyba = "Nedostatek pamti pro vytvoen okna (new_hlavni)\n";
        return 1;
    }
    if ((sub_nadpis = subwin2(new_hlavni, LNADPIS, COLS, 0, 0)) == NULL) {
        endwin2();
        *chyba = "Nelze vytvorit okno \"sub_nadpis\"\n";
        return 1;
    }
    if ((sub_informace =
         subwin2(new_hlavni, HLPRINTLINES - LNADPIS, CSINF, LNADPIS, 0))
        == NULL) {
        endwin2();
        *chyba = "Nelze vytvorit okno \"sub_informace\"\n";
        return 1;
    }

    if ((sub_hlavni =
         subwin2(new_hlavni, HLPRINTLINES - LNADPIS, COLS - CSINF, LNADPIS,
                 CSINF)) == NULL) {
        endwin2();
        *chyba = "Nelze vytvorit okno \"sub_hlavni\"\n";
        return 1;
    }

    if ((sub_radek = subwin2(new_hlavni, 3, COLS, LNADPIS, 0)) == NULL) {
        endwin2();
        *chyba = "Nelze vytvorit okno \"sub_radek\"\n";
        return 1;
    }

    if ((sub_psani = subwin2(new_hlavni, HLPRINTLINES - LNADPIS - 3,
                             COLS, LNADPIS + 3, 0)) == NULL) {
        endwin2();
        *chyba = "Nelze vytvorit okno \"sub_psani\"\n";
        return 1;
    }

    scrollok2(stdscr, TRUE);
    scrollok2(sub_psani, TRUE);

    barevne();                  /* spusti a inicializuje barevne schema */
    wattron2(sub_nadpis, COLOR_PAIR(COLOR_SUB_NADPIS));
    wattron2(sub_hlavni, COLOR_PAIR(COLOR_SUB_HLAVNI));
    wattron2(sub_psani, COLOR_PAIR(COLOR_SUB_PSANI));
    wattron2(sub_informace, COLOR_PAIR(COLOR_SUB_INFORMACE));

    pridej_do_priority_w(1, new_hlavni, stdscr, LINES - 1, 0);
    tiskni_dle_priority();

    if (keypad2(stdscr, TRUE)) {
        endwin2();
        *chyba = "Nepodail se inicializovat keypad.\n";
        return 1;
    }
    if (noecho2() && (global_get(g_warning) == g_w_ano)) {
        perror("noecho");
        (void) button(chybanoecho, 2, 1, 4, 37,
                      ((LINES - 4) / 2) - 3, ((COLS - 37) / 2) - 1);
    }
    return 0;
}
